if select(2, UnitClass('player')) ~= "HUNTER" then
	return
end
local L = AceLibrary("AceLocale-2.2"):new("KingOfTheJungle")
local FL = AceLibrary:GetInstance("FrameLib-1.0")

local KOTJUIMAINFRAME = nil
local KOTJUITABS = {L["Options"],L["Foods"],L["Diets"]}
local KOTJUITABOPTIONFRAME = nil
local KOTJUITABFOODFRAME = nil
local KOTJUITABDIETFRAME = nil

function KingOfTheJungle:KOTJUI_Show()
	if not KOTJUIMAINFRAME then
		KOTJUIMAINFRAME = self:KOTJUI_CreateFrame()
		self:KOTJUI_CreateTabs()
	end
	
	if not KOTJUITABOPTIONFRAME then
		KOTJUITABOPTIONFRAME = self:KOTJUI_CreateOptions(KOTJUIMAINFRAME,384,512)		
	end
	
	if not KOTJUITABFOODFRAME then
		KOTJUITABFOODFRAME = self:KOTJUI_CreateFoodLists(KOTJUIMAINFRAME,384,512)		
	end
	
	if not KOTJUITABDIETFRAME then
		KOTJUITABDIETFRAME = self:KOTJUI_CreateDiets(KOTJUIMAINFRAME,384,512)		
	end
	
	PanelTemplates_SetNumTabs(KOTJUIMAINFRAME, #KOTJUITABS)
	KOTJUIMAINFRAME.selectedTab = 1
	PanelTemplates_UpdateTabs(KOTJUIMAINFRAME)

	KOTJUITABFOODFRAME:Hide()
	KOTJUITABDIETFRAME:Hide()
	KOTJUIMAINFRAME:Hide()
	KOTJUITABOPTIONFRAME:Hide()
	
	KOTJUIMAINFRAME:Show()
	KOTJUITABOPTIONFRAME:Show()
end

function KingOfTheJungle:KOTJUI_HandlerTabButton(buttonname)
	button = getglobal(buttonname)
	KOTJUITABOPTIONFRAME:Hide()
	KOTJUITABDIETFRAME:Hide()
	KOTJUITABFOODFRAME:Hide()
	
	if button:GetText() == L["Options"] then
		KOTJUITABOPTIONFRAME:Show()
	elseif button:GetText() == L["Foods"] then
		KOTJUITABFOODFRAME:Show()
	elseif button:GetText() == L["Diets"] then
		KOTJUITABDIETFRAME:Show()
	end
end

function KingOfTheJungle:KOTJUI_CreateTabs()
	local x = 20
	local padding = 24
	for i,v in pairs(KOTJUITABS) do
		local b = FL:CreateFrame({frame = FL.UIOBJECT.BUTTON, name = KOTJUIMAINFRAME:GetName().."Tab"..i, parent = KOTJUIMAINFRAME, inherits = "CharacterFrameTabButtonTemplate",
									setpoint = {point = FL.ANCHOR.BOTTOMLEFT, x = x, y =45},
									value = {id = i, text = v}})
		
		PanelTemplates_TabResize(0, b)
	
		b:SetScript("OnClick", function() 
			PanelTemplates_Tab_OnClick(KOTJUIMAINFRAME)
			self:KOTJUI_HandlerTabButton(this:GetName())
		end )
		
		x = x + b:GetTextWidth() + padding
	end	
end

function KingOfTheJungle:KOTJUI_CreateFrame()  	
	local f = FL:CreateFrame({frame = FL.UIOBJECT.FRAME, name = "KOTJUIMainFrame", parent = UIParent, width = 384, height = 512,
								strata = FL.STRATA.BACKGROUND, clamptoscreen = true, movable = true, enablemouse = true, registerfordrag = "LeftButton",
								setpoint = {point = FL.ANCHOR.CENTER, x = 0, y = 0},
								hitrectinsets = {left = 0, right = 30, top = 0, bottom = 45}})
	
--~ BACKGROUND TEXTURES	
--~ Portrait
	local portrait = FL:CreateTexture({parent = f, layer = FL.LAYER.BACKGROUND, width = 60, height = 60,
											setpoint = {point = FL.ANCHOR.TOPLEFT, x = 7, y = -6}})

	local t = nil
--~ BORDER TEXTURES	
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.BORDER, width = 256, height = 256, texture = "Interface\\PaperDollInfoFrame\\UI-Character-General-TopLeft.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 2, y = -1}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.BORDER, width = 128, height = 256, texture = "Interface\\PaperDollInfoFrame\\UI-Character-General-TopRight.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 258, y = -1}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.BORDER, width = 256, height = 256, texture = "Interface\\PaperDollInfoFrame\\UI-Character-General-BottomLeft.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 2, y = -257}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.BORDER, width = 128, height = 256, texture = "Interface\\PaperDollInfoFrame\\UI-Character-General-BottomRight.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 258, y = -257}})
--~ ARTWORK TEXTURES
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.ARTWORK, width = 256, height = 256, texture = "Interface\\TalentFrame\\HunterBeastMastery-TopLeft.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 23, y = -77}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.ARTWORK, width = 64, height = 256, texture = "Interface\\TalentFrame\\HunterBeastMastery-TopRight.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 279, y = -77}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.ARTWORK, width = 256, height = 128, texture = "Interface\\TalentFrame\\HunterBeastMastery-BottomLeft.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 23, y = -333}})
	t = FL:CreateTexture({parent = f, layer = FL.LAYER.ARTWORK, width = 64, height = 128, texture = "Interface\\TalentFrame\\HunterBeastMastery-BottomRight.blp",
									setpoint = {point = FL.ANCHOR.TOPLEFT, x = 279, y = -333}})
--~ FONTS
	local font = FL:CreateFontString({parent = f, layer = FL.LAYER.ARTWORK, inherits = "GameFontNormal", text = L["King of the Jungle"],
										setpoint = {point = FL.ANCHOR.TOP, x = 0, y = -20}})
--~ BUTTONS
	local b = FL:CreateFrame({frame = "Button", parent = f, inherits = "UIPanelCloseButton",
								setpoint = {point = FL.ANCHOR.CENTER, frame = f, relpoint = FL.ANCHOR.TOPRIGHT, x = -44, y = -25}})
--~ EVENT HANDLERS	
	b:SetScript("OnClick", function() 
		f:Hide()
	end )
	
	f:SetScript("OnDragStart", function()
		this:StartMoving()		
	end)
	f:SetScript("OnDragStop", function()
		this:StopMovingOrSizing()		
	end)
	f:SetScript("OnUpdate", function()
		if UnitExists("pet") then
			SetPortraitTexture(portrait,"pet")
		else
			portrait:SetTexture("Interface\\CharacterFrame\\TemporaryPortrait-Monster.blp")
		end
	end)	
	
	return f	
end